#include <stdio.h>
#include <stdlib.h>

double ** vyroba_pole(int r, int s)
{
    double **p_2p;
    int i;
    p_2p=(double **)malloc(r*sizeof(double *));
    for(i=0; i<r; i++)
    {
        p_2p[i]=(double *)malloc(s*sizeof(double));
    }
    return(p_2p);
}
void napln_pole(double **p_2p, int r, int s)
{
    int i,j;
    for(i=0; i<r; i++)
    {
        for(j=0; j<s; j++)
        {
            printf("Zadej prvek na pozici [%d][%d]: ",i+1,j+1);
            scanf("%lf",&(p_2p[i][j]));
        }
    }
}
void tisk(double **p_2p, int r, int s)
{
    int i,j;
    for(i=0; i<r; i++)
    {
        for(j=0; j<s; j++)
        {
            printf("%g\t",p_2p[i][j]);
        }
        printf("\n");
    }
}
void uvolneni(double **p_2p, int r, int s)
{
    int i;
    for(i=0; i<r; i++)
        free((void *)p_2p[i]);
    free((void **)p_2p);
}
int main()
{
    double **p_A;
    int r,s;
    printf("Zadej pocet radku a sloupcu:\n");
    scanf("%d %d",&r,&s);
    if((r<=0)&&(s<=0))
    {
        printf("Chyba v zadani\n");
        return -1;
    }
    p_A=vyroba_pole(r,s);
    napln_pole(p_A,r,s);
    tisk(p_A,r,s);
    uvolneni(p_A,r,s);
    return 0;
}
